import java.util.ArrayList;
import java.util.Collections;

class OperationSystem implements Comparable<OperationSystem > {
    String  productName;
    double  marketShare;

    // constracter
    public OperationSystem(String osname, double share) {
        this.productName = osname;
        this.marketShare = share;
    }

    public String toString() {  // for System.out.println
        return this.productName + " : " + this.marketShare + "%";
    }

    @Override
    public int compareTo(OperationSystem o) {
        if (o.marketShare < this.marketShare) return 1;
        if (o.marketShare > this.marketShare) return -1;
        return 0;
    }
}

public class OrigListSort {
    public static void main(String[] args) {
        ArrayList<OperationSystem> osl = new ArrayList<OperationSystem>();

        // set data
        osl.add(new OperationSystem("Windows 8.1", 3.0D));
        osl.add(new OperationSystem("Windows 10", 27.0D));
        osl.add(new OperationSystem("Windows XP", 7.0D));
        osl.add(new OperationSystem("macOS", 2.0D));
        osl.add(new OperationSystem("Windows 7", 49.0D));
        osl.add(new OperationSystem("Linux", 1.0D));

        System.out.println("-- sort --");
        System.out.println("before: " + osl);
        Collections.sort(osl);
        System.out.println("Collections.sort: " + osl);

        System.out.println("-- reverse --");
        System.out.println("before: " + osl);
        Collections.reverse(osl);
        System.out.println("Collections.reverse: " + osl);
    }
}
